<template>
  <div class="w-full h-[184px] fixed top-0 left-0">
    <SvgAccountBg class="w-full h-full" style="color: var(--background4)" />
  </div>
  <div class="sticky top-0 left-0 account-header z-20 pb-2">
    <div
      class="w-full h-[169px] absolute top-0 left-0 overflow-hidden"
      style="z-index: -1"
    >
      <SvgAccountBg
        class="w-full h-[184px]"
        style="color: var(--background4)"
      />
    </div>
    <div
      class="flex items-center px-4 py-[14px]"
      :class="[isBK8Green ? 'justify-start' : 'justify-end']"
    >
      <div
        v-if="
          themeColor.Text.includes('global') ||
          themeColor.Text.includes('playful')
        "
        class="flex w-full justify-end pr-2 relative"
        style="z-index: 22"
      >
        <theme-desktop-global-components-menu-drawer v-if="!isBSI" />
      </div>
      <utils-mobile-tiny-user-center v-else-if="allowCompany && isStyleTwo" />
      <div v-else-if="allowCompany && isStyleThree" class="flex">
        <m-header-style-module-tiny-hamburger
          is-color-text04="true"
          class="relative"
          :is-user-center="true"
        />
      </div>
      <new-black-theme-hamburger-menu v-else class="!text-[var(--text4)]" />
    </div>
    <div class="px-2 relative z-10">
      <utils-mobile-account-information />
    </div>
  </div>
  <div class="px-2 flex flex-col gap-2 pb-4 relative z-10">
    <div class="flex flex-col rounded-lg bg-background5">
      <div class="flex flex-col">
        <template v-for="(menu, index) in menuList" :key="`menu-${index}`">
          <a
            v-if="menu.label === 'agent_cooperation'"
            :id="menu.id"
            class="py-1 m-profile-menu-item"
            @click.prevent="toggleAgentCooperation"
          >
            <div
              class="flex items-center justify-between"
              :class="{ 'pointer-events-none': !!menu.id }"
            >
              <div class="flex items-center tc-5">
                <div
                  v-if="menu.icon"
                  class="w-10 h-10 flex items-center justify-center tc-5"
                >
                  <component :is="menu.icon" class="w-6 h-6"></component>
                </div>
                <span class="profile-menu-title">{{ $t(menu.label) }}</span>
              </div>
              <div class="flex items-center m-angle-right-container">
                <font-awesome-icon icon="angle-right" />
              </div>
            </div>
          </a>
          <nuxt-link
            v-else-if="menu.url"
            :id="menu.id"
            class="py-1 m-profile-menu-item"
            :to="menu.url"
            @click="menu.onClick"
          >
            <div
              class="flex items-center justify-between"
              :class="{ 'pointer-events-none': !!menu.id }"
            >
              <div class="flex items-center tc-5">
                <div
                  v-if="menu.icon"
                  class="w-10 h-10 flex items-center justify-center tc-5"
                >
                  <component :is="menu.icon" class="w-6 h-6"></component>
                </div>
                <span class="profile-menu-title">{{ $t(menu.label) }}</span>
                <div
                  v-if="menu.url === '/messages' && unreadInfo?.TotalCount"
                  class="w-10 h-10 flex items-center justify-center"
                >
                  <MessagesMessageCount
                    :count="unreadInfo.TotalCount"
                    :is-unread="true"
                    class="!ml-2"
                  ></MessagesMessageCount>
                </div>
              </div>
              <div class="flex items-center m-angle-right-container">
                <font-awesome-icon icon="angle-right" />
              </div>
            </div>
          </nuxt-link>
        </template>
      </div>
    </div>

    <div
      v-if="!isHelpCenterHidden"
      class="flex flex-col rounded-lg bg-background5"
    >
      <nuxt-link
        class="py-1 m-profile-menu-item"
        to="/help-center"
        @click="setBacktoNavigation"
      >
        <div class="flex justify-between items-center">
          <div class="flex items-center fc-text">
            <div class="w-10 h-10 flex items-center justify-center tc-5">
              <IconHelpCenter class="w-6 h-6" />
            </div>
            <span class="profile-menu-title">
              {{ isPlayful ? $t("about_us") : $t("help_center") }}
            </span>
          </div>
          <div class="flex items-center m-angle-right-container">
            <font-awesome-icon icon="angle-right" />
          </div>
        </div>
      </nuxt-link>
    </div>

    <UtilsMobileLanguageSelection @expanded="onScrollToLastLangElement" />

    <div class="flex flex-col rounded-lg bg-background5 cursor-pointer">
      <a class="py-1 m-profile-menu-item" @click.prevent="onLogout">
        <div class="flex justify-between items-center">
          <div class="flex items-center fc-text">
            <div class="w-10 h-10 flex items-center justify-center tc-5">
              <IconSignOut class="w-6 h-6" />
            </div>
            <span class="profile-menu-title">{{ $t("logout") }}</span>
          </div>
          <div class="flex items-center m-angle-right-container">
            <font-awesome-icon icon="angle-right" />
          </div>
        </div>
      </a>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { computed, type Component } from "vue";
import { useHeaderComponent } from "@/composables/useTheme";
import { store } from "@/store";
import useHeaderRender from "@/composables/useHeaderRender";
import { IThemePropertiesFromApi } from "~~/models/companyThemePropertiesRespone";
import SvgAccountBg from "~/assets/svg/account-bg.svg?component";
import IconUser from "~/assets/icons/user.svg?component";
import IconWallet from "~/assets/icons/wallet.svg?component";
import IconBetHistory from "~/assets/icons/bet-history.svg?component";
import IconStatement from "~/assets/icons/statement.svg?component";
import IconMessage from "~/assets/icons/message.svg?component";
import IconHelpCenter from "~/assets/icons/help-center.svg?component";
import IconSignOut from "~/assets/icons/sign-out.svg?component";
import IconReferral from "~/assets/icons/referral.svg?component";
import IconAgentCooperation from "~/assets/icons/agent-cooperation.svg?component";
import { appNavigationStore } from "~~/store/app-navigation";
import EnumMutation from "~~/models/enums/enumMutation";

type TMenuList = {
  label: string;
  url?: string;
  icon?: Component;
  id?: string;
  onClick?: Function;
};
const toggleAgentCooperation = () => {
  store.commit(
    "updateAgentCooperationDialog",
    !store.state.showAgentCooperationDialog
  );
};
const { logout, referralEnabled, agentCooperation } = useHeaderComponent();
const isPlayful = computed(
  (): boolean => store.state.selectedThemeName === "playful"
);
const { isStyleTwo, isStyleThree } = useHeaderRender();
const isBSI = computed(() => !store.state.auth);
const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
const themeProperties = computed(
  () => store.state.companyThemePropertiesFromApi.ThemeProperties
);
const isHelpCenterHidden = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "help_center"
    )
).value.IsHidden;
const onLogout = () => {
  logout();
};
const { themeColor } = themePropertyHelper;
const { fetchMessages, unreadInfo } = useMessage();
const route = useRoute();
const isBK8Green = computed(() => themeColor.value.Text === "bk8_green");

const setBacktoNavigation = () => {
  appNavigationStore.commit(
    EnumMutation.updateAppNavigationBackToRoute,
    "/profile"
  );
};

const { allowCompany } = commonHelper;

const menuList = computed(() => {
  const menus: TMenuList[] = [
    {
      url: "/account",
      label: "profile",
      icon: IconUser,
      id: ID.USER_CENTER.ACCOUNT,
      onClick: setBacktoNavigation,
    },
    {
      url: "/wallet",
      label: "wallet",
      icon: IconWallet,
      id: ID.USER_CENTER.WALLET,
      onClick: setBacktoNavigation,
    },
    {
      url: "/bet-history",
      label: "bet_history",
      icon: IconBetHistory,
      id: ID.USER_CENTER.BET_HISTORY,
      onClick: setBacktoNavigation,
    },
    {
      url: "/transaction-history",
      label: "statement",
      icon: IconStatement,
      id: ID.USER_CENTER.TRANSACTION_HISTORY,
      onClick: setBacktoNavigation,
    },
    {
      url: "/referral",
      label: "referral",
      icon: IconUser,
      id: ID.USER_CENTER.REFERRAL,
      onClick: setBacktoNavigation,
    },
    {
      url: "/referral-v2/information",
      label: "referral",
      icon: IconReferral,
      id: ID.USER_CENTER.REFERRAL,
      onClick: setBacktoNavigation,
    },
    {
      url: "/messages",
      label: "messages",
      icon: IconMessage,
      id: ID.USER_CENTER.MESSAGE,
      onClick: setBacktoNavigation,
    },
    {
      label: "agent_cooperation",
      icon: IconAgentCooperation,
      onClick: setBacktoNavigation,
    },
  ];

  return menus.filter((menu) => {
    let isShow = true;
    if (
      menu.url === "/referral" &&
      !(referralEnabled.value && !store.state.isV2ReferralEnabled)
    ) {
      isShow = false;
    }
    if (
      menu.url === "/referral-v2/information" &&
      !store.state.isV2ReferralEnabled &&
      !isShowReferralPage.value
    ) {
      isShow = false;
    }
    if (menu.label === "agent_cooperation" && agentCooperation.value.IsHidden) {
      isShow = false;
    }
    return isShow;
  });
});

const onScrollToLastLangElement = (lastEl: HTMLElement) => {
  lastEl.scrollIntoView({
    behavior: "smooth",
    block: "start",
  });
};

onMounted(() => {
  if (!route.fullPath.includes("messages")) {
    fetchMessages();
  }
});

const isIndependentModule = useState(KEYS.IS_INDEPENDENT_MODULE);
</script>

<style lang="scss" scoped>
:deep(.el-collapse-item__content) {
  padding-bottom: 0px;
}

.profile-menu-title {
  color: var(--text5);
}

.language-icon {
  width: 22px;
  height: 16px;
  border: 1px solid var(--border);
  border-radius: 2px;
  object-fit: cover;
}

.m-profile-menu-item {
  padding-left: 12px;
  padding-right: 16px;

  .profile-menu-title {
    font-family: Roboto;
    font-size: 14px;
    font-weight: 400;
    line-height: 16.41px;
    text-align: left;
    color: var(--text5);
  }
}

.el-collapse {
  --el-collapse-content-bg-color: none;
  --el-collapse-header-bg-color: none;
  border: none;
  :deep(.el-collapse-item__arrow) {
    font-weight: bold;
    color: var(--text);
  }
}
:deep(.icon svg) {
  width: 24px;
  height: 24px;
}
:deep(.icon svg path) {
  fill: var(--text);
}
.icon-lang {
  img {
    width: 100%;
    height: 100%;
    border-radius: 2px;
    object-fit: cover;
  }
  height: 16px;
  width: 22px;
  border-radius: 2px;
  background: #fff;
}
[theme-color="bk8_green"] .hamburger-pos {
  @apply left-4;
  top: 13px;
}
</style>
<style lang="scss">
.background-header-title {
  position: absolute;
  height: 184px;
  width: 100%;
  background-color: var(--background4);
  top: 0;
  left: 0;
  &::before {
    content: "";
    position: absolute;
    top: 0;
    left: 0;
    height: 100%;
    width: 100%;
    background: var(--background4);
  }
  > div {
    position: absolute;
    &:first-child {
      background: linear-gradient(
        199.22deg,
        rgba(255, 255, 255, 0) 12.93%,
        rgba(255, 255, 255, 0.1) 83.18%
      );
      width: 170px;
      height: 170px;
      border-radius: 50%;
      top: -75px;
      left: -33px;
      transform: rotate(75deg);
    }
    &:nth-child(2) {
      background: linear-gradient(
        219.67deg,
        rgba(255, 255, 255, 0) 22.41%,
        rgba(255, 255, 255, 0.1) 116.98%
      );
      width: 370px;
      height: 370px;
      border-radius: 50%;
      top: -152px;
      left: 77px;
    }
    &:last-child {
      background: linear-gradient(
        199.22deg,
        rgba(255, 255, 255, 0) 12.93%,
        rgba(255, 255, 255, 0.1) 83.18%
      );
      width: 250px;
      height: 250px;
      border-radius: 50%;
      top: -147px;
      right: -69px;
    }
  }
}
.m-profile-menu-item {
  border-bottom: none;

  &:not(:last-child) {
    position: relative;

    &:after {
      content: "";
      position: absolute;
      left: 0;
      bottom: 0;
      width: 100%;
      height: 1px;
      background: var(--borderD500);
    }
  }
}
.m-angle-right-container {
  height: 20px;
  width: 20px;
  display: flex;
  justify-content: center;
  color: var(--text5);
}
.m-angle-right-container svg {
  font-size: 16.31px;
}
.el-collapse-item__arrow {
  display: none;
}
.el-collapse-item__header,
.el-collapse-item__wrap {
  border-bottom: unset;
}
.el-collapse-item .m-language-collapse {
  transition: transform 0.3s ease-in-out;
}
.el-collapse-item.is-active .m-language-collapse {
  transform: rotate(-180deg);
}
.m-profile-item-btn {
  font-size: 15.82px;
  color: var(--textBtn);
  border: unset;
  padding: var(--padding-x);
  height: 52.31px;
  border-radius: 0.5rem;
}
.padding-y {
  padding-top: 12.25px;
  padding-bottom: 12.25px;
}
.m-margin-unset {
  margin-top: 10px;
}
</style>
